runtest: the saga continues :(
[oweals/busybox.git] / testsuite / runtest
1 #!/bin/sh
2
3 # Usage:
4 # runtest [applet1] [applet2...]
5
6 # Run one old-style test.
7 # Tests are stored in applet/testcase shell scripts.
8 # They are run using "sh -x -e applet/testcase".
9 # Option -e will make testcase stop on the first failed command.
10 run_applet_testcase()
11 {
12         local applet="$1"
13         local testcase="$2"
14
15         local status
16         local uc_applet=$(echo "$applet" | tr a-z A-Z)
17         local testname="$testcase"
18
19         testname="${testname##*/}" # take basename
20         if grep "^# CONFIG_$uc_applet is not set$" "$bindir/.config" >/dev/null; then
21                 echo "UNTESTED: $testname"
22                 return 0
23         fi
24
25         if grep "^# FEATURE: " "$testcase" >/dev/null; then
26                 local feature=$(sed -ne 's/^# FEATURE: //p' "$testcase")
27
28                 if grep "^# $feature is not set$" "$bindir/.config" >/dev/null; then
29                         echo "UNTESTED: $testname"
30                         return 0
31                 fi
32         fi
33
34         rm -rf ".tmpdir.$applet"
35         mkdir -p ".tmpdir.$applet"
36         cd ".tmpdir.$applet" || return 1
37
38 #       echo "Running testcase $testcase"
39         d="$tsdir" sh -x -e "$testcase" >"$testname.stdout.txt" 2>&1
40         status=$?
41         if [ $status -ne 0 ]; then
42                 echo "FAIL: $testname"
43                 if [ x"$VERBOSE" != x ]; then
44                         cat "$testname.stdout.txt"
45                 fi
46         else
47                 echo "PASS: $testname"
48         fi
49
50         cd ..
51         rm -rf ".tmpdir.$applet"
52
53         return $status
54 }
55
56 # Run all old-style tests for given applet
57 run_oldstyle_applet_tests()
58 {
59         local applet="$1"
60         local status=0
61
62         for testcase in "$tsdir/$applet"/*; do
63                 # switch on basename of $testcase
64                 case "${testcase##*/}" in
65                         .*)     continue ;;    # .svn, .git etc
66                         *~)     continue ;;    # backup files
67                         "CVS")  continue ;;
68                         \#*)    continue ;;    # CVS merge residues
69                         *.mine) continue ;;    # svn-produced junk
70                         *.r[0-9]*) continue ;; # svn-produced junk
71                 esac
72                 run_applet_testcase "$applet" "$testcase"
73                 test $? -eq 0 || status=1
74         done
75         return $status
76 }
77
78
79
80 lcwd=$(pwd)
81 [ x"$tsdir" != x ] || tsdir="$lcwd"
82 [ x"$bindir" != x ] || bindir="${lcwd%/*}" # one directory up from $lcwd
83 PATH="$bindir:$PATH"
84
85 if [ x"$VERBOSE" = x ]; then
86         export VERBOSE=
87 fi
88
89 if [ x"$1" = x"-v" ]; then
90         export VERBOSE=1
91         shift
92 fi
93
94 implemented=$(
95         "$bindir/busybox" 2>&1 |
96         while read line; do
97                 if [ x"$line" = x"Currently defined functions:" ]; then
98                         xargs | sed 's/,//g'
99                         break
100                 fi
101         done
102         )
103
104 applets="$implemented"
105 if [ $# -ne 0 ]; then
106         applets="$@"
107 fi
108
109 # Populate a directory with links to all busybox applets
110
111 LINKSDIR="$bindir/runtest-tempdir-links"
112 rm -rf "$LINKSDIR" 2>/dev/null
113 mkdir "$LINKSDIR"
114 for i in $implemented; do
115         ln -s "$bindir/busybox" "$LINKSDIR/$i"
116 done
117
118 # Set up option flags so tests can be selective.
119 export OPTIONFLAGS=:$(
120         sed -nr 's/^CONFIG_//p' "$bindir/.config" |
121         sed 's/=.*//' | xargs | sed 's/ /:/g'
122         )
123
124 status=0
125 for applet in $applets; do
126         # Any old-style tests for this applet?
127         if [ -d "$tsdir/$applet" ]; then
128                 run_oldstyle_applet_tests "$applet"
129                 test $? -eq 0 || status=1
130         fi
131
132         # Is this a new-style test?
133         if [ -f "$applet.tests" ]; then
134                 if [ ! -h "$LINKSDIR/$applet" ]; then
135                         # (avoiding bash'ism "${applet:0:4}")
136                         if ! echo "$applet" | grep "^all_" >/dev/null; then
137                                 echo "SKIPPED: $applet (not built)"
138                                 continue
139                         fi
140                 fi
141 #               echo "Running test $tsdir/$applet.tests"
142                 PATH="$LINKSDIR:$tsdir:$bindir:$PATH" "$tsdir/$applet.tests"
143                 test $? -eq 0 || status=1
144         fi
145 done
146
147 # Leaving the dir makes it somewhat easier to run failed test by hand
148 #rm -rf "$LINKSDIR"
149
150 if [ $status -ne 0 ] && [ x"$VERBOSE" = x ]; then
151         echo "Failures detected, running with -v (verbose) will give more info"
152 fi
153 exit $status